package guibnf;
/*
 * Parser.java
 *
 * Created on 6 ottobre 2007, 16.16
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

import java.io.*;
import java.util.*;

/**
 *
 * @author dario
 */
public class Parser {
    
    /** Creates a new instance of Parser */
    public Parser() {
        /**Creo un bel nuovo Random*/
        numeroCasuale = new Random();
        
        /**Creo costanti e regole*/
        costanti = new HashMap<String, String>();
        regole = new HashMap<String, String[]>();
        
        /**Azzero maiuscolo e minuscolo*/
        maiuscolo = 0;
        minuscolo = 0;
    }
    
    /**Fa la scansione di un file, e fa analizzare ogni riga dalla funzione aggiungiRegola
     *Lo stream sorgente viene incapsulato in un BufferedReader, da cui poi
     *la funzione estrarr tutte le varie righe, analizzandole una ad una
     */
    public void caricaGrammatica(StringReader sorgente) throws IOException {
        
        BufferedReader in = null;
        
        try {
//            in = new BufferedReader(new FileReader(nome));
            in = new BufferedReader(sorgente);
            String riga;
            
            riga = in.readLine();
            
            while (riga != null) {
                
                /**Il compito di aggiungere le regole  demandato ad una
                 *funzione separata, per comodit
                 */
                aggiungiRegola(riga);
                riga = in.readLine();
            }
        }
        finally {
         //   if (in != null) in.close();
            
        }
    }
    
    /**
     * Aggiunge una regola a partire da una stringa
     */
    void aggiungiRegola(String linea) {
        
        /**La stringa prima  la parte sinistra della riga,
         *quella che precede il ::=
         *La stringa dopo invece  la parte dopo il ::=
         */
        String prima, dopo; 
        
        /**String[] splittato serve per contenere le 2 parti, quelle prima
         *e dopo il ::=, prima di essere trimmate. In effetti le stringhe
         *prima e dopo servono solo per comodit
         */                        
        String[] splittato, listaRegole;
        
        /**Le regole hanno come Valore un Vector<String>*/
        Vector<String> lista = new Vector<String>();
        
        /**Divido la linea in input in ci che precede il ::= e in ci che lo segue*/
        splittato = linea.split("::=");
        
        if (splittato.length == 2) {
            
            /**Tolgo gli spazi all'inizio e alla fine delle stringhe*/
            prima = splittato[0].trim();
            dopo = splittato[1].trim();
                                
            /**La prima parte dello splittato  il nome della regola*/
            listaRegole = dopo.split("#");
            
            /**Adesso aggiungo la regola alla mappa delle regole*/
            regole.put(prima, listaRegole);
            
        }
        
    }
    
    /**Questo metodo produce effettivamente del testo a partire dalla BNF caricata.
     * La String scopo che viene passata come argomento, se non indicata, viene sostituita
     * direttamente da scopo, come default
     */
    public String produci(String scopo) {
        
        String finale = ""; //La stringa che restituir come risultato
        String analizzanda; //Mi serve pi in basso
        String[] regola; //L'array che contiene le regole per ogni scopo
        
        /**Se scopo  vuoto, uso come scopo di default la stringa "scopo"*/
        if (scopo == "") scopo = "scopo";
        
        /*Devo trovare la regola che corrisponde al nome di scopo
         *nella mappa delle regole
         */
        
        regola = regole.get(scopo);
        
        /*Se la regola non esiste, restituisco lo scopo, ed  morta l*/
        if (regola == null) return scopo;
        
        /*Adesso inizio la scansione di ogni singola parte della produzione, che
         *ricordo essere divisa da #
         */
        for (int conto = 0; conto < regola.length; conto ++) {
            
            /*In ogni singolo frammento delimitato da #, se  contenuta una pipe,
             *ovvero una |, vuol dire che c' un'alternativa, e devo scoprirlo
             */
            String[] sceltaMultipla;
            sceltaMultipla = regola[conto].split("[|]");
            
            /*Adesso pesco a caso uno degli elementi selezionati da |
             */
            int quale = numeroCasuale.nextInt(sceltaMultipla.length);
            
            /*La stringa che ho selezionato diventa la mia analizzanda*/
            analizzanda = sceltaMultipla[quale];
            
            /*Ora devo analizzare analizzanda!*/
            int trovato = 0; //flag che mi dice se ho trovato un $ o no
            String dollaro = ""; //la stringa dollarosa che dovr reanalizzare
            char caratterino; //il carattere che man mano analizzo
            
            /*Comincio l'analisi di ogni singolo carattere di analizzanda*/
            for (int contatore = 0; contatore < analizzanda.length(); contatore++) {
                
                /**caratterino contiene il carattere di analizzanda che sto
                 *analizzando
                 */
                caratterino = analizzanda.charAt(contatore);
                
                
                /**Quando trovo un dollaro, i vari caratteri che leggo li aggiungo
                 *alla String dollaro, che poi sar analizzata per conto suo
                 */
                if (caratterino == '$') {
                    //Ho trovato un $
                    //Controllo se ne ho gi trovato uno
                    if (trovato == 1) {
                        
                        /**Questo controllo mi serve nel caso in cui ho
                         *delle regole cos fatte:
                         *$regola$parola
                         *in cui sia regola che parola possono essere regole
                         *effettive oppure parole normali. Il $  un separatore
                         *a tutti gli effetti, con precedenza inferiore al #
                         */
                        finale = finale + comando(dollaro); //Produco la stringa dollaro
                        dollaro = ""; //Svuoto la stringa dollaro, perch siamo nel caso descritto qui sopra
                    }
                    else trovato = 1; //Ho trovato un dollaro
                }
                else {
                    if (trovato == 1) {
                        /*Ho gi trovato un dollaro
                         */
                        if ((caratterino == ' ') || (caratterino == ';')) { //controllo se il carattere  uno spazio
                            trovato = 0; //trovato adesso  0
                            finale = finale + /*controllaMaiusMinus*/(comando(dollaro));
                            dollaro = ""; //svuoto la stringa dollaro
                            if (caratterino == ' ') finale = finale + caratterino;
                        }
                        else  {
                            /**Aggiungo il carattere alla stringa dollaro
                             */
                            dollaro = dollaro + caratterino;
                        }
                        
                    }
                    else {
                        
                        /*Qui controllo se il carattere deve essere reso maiuscolo
                         *o minuscolo.
                         */
                        if (maiuscolo == 1) {
                            caratterino = (new Character(caratterino)).toUpperCase(caratterino);
                            maiuscolo = 0;
                        }
                        
                        if (minuscolo == 1) {
                            caratterino = (new Character(caratterino)).toLowerCase(caratterino);
                        }
                         
                        finale = finale + caratterino;
                    }
                }
            }
            
            if (trovato == 1) finale = finale + comando(dollaro);
        }
        
        return finale;
    }
    
    String comando(String linea) {
        String finale = ""; //La stringa che restituir come risultato
        String[] regola; //L'array che contiene le regole per ogni scopo
        
        /**Vado a pescare la regola*/
        regola = regole.get(linea);
        
        if (regola != null) {
            
            /**Se non  una regola, la produco, pu essere qualcos'altro
             */
            finale = finale + produci(linea);
        }
        
        else {
            
            /**Qui cominciano tutti i controlli per i vari metacomandi
             *che posso incontrare dopo un $
             */
            
            if (linea.equals("MAIUS")) maiuscolo = 1;
            else if (linea.equals("MINUS")) minuscolo = 1;
            
            else if (linea.equals("\\n")) finale = "\n";
                        
            else if (linea.equals("\\t")) finale = "\t";
            
            else if (linea.length() == 0) finale = "$";
            
            else if (linea.charAt(0) == '%') {
               
                /*Se trovo un %, vuol dire che sto usando delle
                 *costanti.
                 *Quindi, prima vado a vedere se esistono gi le costanti 
                 *nell'apposita mappa. Se s, semplicemente le prelevo e le
                 *restituisco. Se no, genero quello che viene indicato, e lo salvo
                 *nella mappa delle costanti
                 */
                String iter; /*Il nome di questa stringa  un relitto degli 
                              *iteratori che usavo nella versione C++
                              */
                
                /**Cerco se c' questa stringa nelle costanti.
                 *Il motivo di linea.substring(1)  che ovviamente il primo
                 *carattere  un %, quindi non mi serve ai fini della ricerca
                 */
                iter = costanti.get(linea.substring(1));
                
                if (iter == null) {
                    
                    /*Non ho trovato la costante, quindi la produco, la restituisco
                     *e aggiorno le costanti
                     */
                    finale = produci(linea.substring(1));
                    costanti.put(linea.substring(1), finale);
                }
                else {

                    /*Invece la regola c'era: la restituisco
                     */
                    finale = iter;
                }
            }
            else {
                
                /*Se non c'era niente di tutto ci produco la linea e ciao.*/
                finale = finale + produci(linea);
            }
            
        }
        
        
        return finale;
    }
    
    
    /** Resetta tutte le costanti
     */
    public void resettaCostanti() {
        if (costanti != null) costanti.clear();        
    }
    
    /** Resetta le costanti, le regole e le variabili maiuscolo e minuscolo */
    public void resettaTutto() {
        if (costanti != null) costanti.clear();
        if (regole != null) regole.clear();
        maiuscolo = 0;
        minuscolo = 0;
    }
    
    int maiuscolo;
    int minuscolo;
    
    HashMap<String, String> costanti;
    HashMap<String, String[]> regole;
    
    Random numeroCasuale;
}
